ArgumentException ArgumentException ArgumentException ArgumentException Class

Definition

Die Ausnahme, die ausgelöst wird, wenn eines der Argumente für eine Methode ungültig ist. The exception that is thrown when one of the arguments provided to a method is not valid.

public ref class ArgumentException : SystemException
[System.Runtime.InteropServices.ComVisible(true)]
[Serializable]
public class ArgumentException : SystemException
type ArgumentException = class
    inherit SystemException
    interface ISerializable
Public Class ArgumentException
Inherits SystemException
Inheritance
Derived
Attributes
ComVisibleAttribute SerializableAttribute
Implements

Examples

Im folgende Beispiel wird veranschaulicht, wie auslösen und Abfangen einer ArgumentException.The following example demonstrates how to throw and catch an ArgumentException. Er verwendet den ArgumentException.GetType(). Namen Eigenschaft zum Anzeigen der Name der Exception-Objekt, und außerdem verwendet die Message Eigenschaft, um den Text der Ausnahmemeldung anzuzeigen.It uses the ArgumentException.GetType().Name property to display the name of the exception object, and also uses the Message property to display the text of the exception message.

using namespace System;

static int DivideByTwo(int num) 
{
    // If num is an odd number, throw an ArgumentException.
    if ((num & 1) == 1)
        throw gcnew ArgumentException(String::Format("{0} is not an even number", num), 
                                      "num");

    // num is even, return half of its value.
    return num / 2;
}

void main() 
{
    // Define some integers for a division operation.
    array<int>^ values = { 10, 7 };
    for each (int value in values) {
        try {
           Console::WriteLine("{0} divided by 2 is {1}", value, DivideByTwo(value));
        }
        catch (ArgumentException^ e) {
           Console::WriteLine("{0}: {1}", e->GetType()->Name, e->Message);
        }
        Console::WriteLine();
    }
}
// This example displays the following output:
//     10 divided by 2 is 5
//     
//     ArgumentException: 7 is not an even number
//     Parameter name: num
using System;

public class Example 
{
    static void Main() 
    {
        // Define some integers for a division operation.
        int[] values = { 10, 7 };
        foreach (var value in values) {
            try {
               Console.WriteLine("{0} divided by 2 is {1}", value, DivideByTwo(value));
            }
            catch (ArgumentException e) {
               Console.WriteLine("{0}: {1}", e.GetType().Name, e.Message);
            }
            Console.WriteLine();
        }
    }

    static int DivideByTwo(int num) 
    {
        // If num is an odd number, throw an ArgumentException.
        if ((num & 1) == 1)
            throw new ArgumentException(String.Format("{0} is not an even number", num), 
                                      "num");

        // num is even, return half of its value.
        return num / 2;
    }
}
// This example displays the following output:
//     10 divided by 2 is 5
//     
//     ArgumentException: 7 is not an even number
//     Parameter name: num
Public Class Example
    Public Shared Sub Main()
        ' Define some integers for a division operation.
        Dim values() As Integer = { 10, 7 }

        For Each value In values
            Try 
               Console.WriteLine("{0} divided by 2 is {1}", value, DivideByTwo(value))
            Catch e As ArgumentException
               Console.WriteLine("{0}: {1}", e.GetType().Name, e.Message)
            End Try
            Console.WriteLine()
        Next
    End Sub
    
    Private Shared Function DivideByTwo(ByVal num As Integer) As Integer
        ' If num is an odd number, throw an ArgumentException.
        If (num And 1) = 1 Then
            Throw New ArgumentException(String.Format("{0} is not an even number", num), 
                                      "num")
        End If
        Return num \ 2
    End Function
End Class
' The example displays the following output:
'     10 divided by 2 is 5
'     
'     ArgumentException: 7 is not an even number
'     Parameter name: num

Remarks

ArgumentException wird ausgelöst, wenn eine Methode aufgerufen wird und mindestens eines der übergebenen Argumente nicht der Parameterspezifikation der aufgerufenen Methode entspricht.ArgumentException is thrown when a method is invoked and at least one of the passed arguments does not meet the parameter specification of the called method. Die ParamName identifiziert das ungültige Argument.The ParamName property identifies the invalid argument.

In den meisten Fällen eine ArgumentException durch die common Language Runtime oder einer anderen Klassenbibliothek ausgelöst, und Entwicklerfehler angibt.Most commonly, an ArgumentException is thrown by the common language runtime or another class library and indicates developer error. Wenn Sie Auslösen einer ArgumentException aus dem Code, Sie sollten sicherstellen, dass der Ausnahme Message Eigenschaft enthält eine sinnvolle Fehlermeldung, die das ungültige Argument und des erwarteten Bereichs von Werten für das Argument beschreibt.If you throw an ArgumentException from your code, you should ensure that the exception's Message property includes a meaningful error message that describes the invalid argument and the expected range of values for the argument.

Die primäre abgeleitete Klassen von ArgumentException sind ArgumentNullException und ArgumentOutOfRangeException.The primary derived classes of ArgumentException are ArgumentNullException and ArgumentOutOfRangeException. Diese abgeleiteten Klassen verwendet werden soll, anstelle von ArgumentException, außer in Fällen, in denen keine abgeleiteten Klassen akzeptabel ist.These derived classes should be used instead of ArgumentException, except in situations where neither of the derived classes is acceptable. Beispielsweise sollten die Ausnahmen von ausgelöst werden:For example, exceptions should be thrown by:

  • ArgumentNullException Wenn null übergeben wird, um eine Methode, die nicht als gültiges Argument annimmt.ArgumentNullException whenever null is passed to a method that does not accept it as a valid argument.

  • ArgumentOutOfRangeException Wenn der Wert eines Arguments außerhalb des Bereichs zulässiger Werte ist. z. B. wenn der Wert "46" übergeben wird als Argument für den Monat während der Erstellung einer DateTime.ArgumentOutOfRangeException when the value of an argument is outside the range of acceptable values; for example, when the value "46" is passed as the month argument during the creation of a DateTime.

Wenn der Aufruf der Methode keine Argumente oder der Fehler dann nicht die Argumente, betrifft InvalidOperationException verwendet werden soll.If the method call does not have any argument or if the failure does not involve the arguments themselves, then InvalidOperationException should be used.

ArgumentException verwendet das HRESULT COR_E_ARGUMENT mit den Wert 0 x 80070057 an.ArgumentException uses the HRESULT COR_E_ARGUMENT, which has the value 0x80070057.

Eine Liste der anfänglichen Eigenschaftswerte für eine Instanz von ArgumentException, finden Sie unter den ArgumentException Konstruktoren.For a list of initial property values for an instance of ArgumentException, see the ArgumentException constructors.

Constructors

ArgumentException() ArgumentException() ArgumentException() ArgumentException()

Initialisiert eine neue Instanz der ArgumentException-Klasse. Initializes a new instance of the ArgumentException class.

ArgumentException(SerializationInfo, StreamingContext) ArgumentException(SerializationInfo, StreamingContext) ArgumentException(SerializationInfo, StreamingContext) ArgumentException(SerializationInfo, StreamingContext)

Initialisiert eine neue Instanz der ArgumentException-Klasse mit serialisierten Daten. Initializes a new instance of the ArgumentException class with serialized data.

ArgumentException(String) ArgumentException(String) ArgumentException(String) ArgumentException(String)

Initialisiert eine neue Instanz der ArgumentException-Klasse mit einer angegebenen Fehlermeldung. Initializes a new instance of the ArgumentException class with a specified error message.

ArgumentException(String, Exception) ArgumentException(String, Exception) ArgumentException(String, Exception) ArgumentException(String, Exception)

Initialisiert eine neue Instanz der ArgumentException-Klasse mit einer angegebenen Fehlermeldung und einem Verweis auf die innere Ausnahme, die diese Ausnahme ausgelöst hat. Initializes a new instance of the ArgumentException class with a specified error message and a reference to the inner exception that is the cause of this exception.

ArgumentException(String, String) ArgumentException(String, String) ArgumentException(String, String) ArgumentException(String, String)

Initialisiert eine neue Instanz der ArgumentException-Klasse mit einer angegebenen Fehlermeldung und dem Namen des Parameters, der die Ausnahme auslöst. Initializes a new instance of the ArgumentException class with a specified error message and the name of the parameter that causes this exception.

ArgumentException(String, String, Exception) ArgumentException(String, String, Exception) ArgumentException(String, String, Exception) ArgumentException(String, String, Exception)

Initialisiert eine neue Instanz der ArgumentException-Klasse mit einer angegebenen Fehlermeldung, dem Parameternamen und einem Verweis auf die innere Ausnahme, die diese Ausnahme verursacht hat. Initializes a new instance of the ArgumentException class with a specified error message, the parameter name, and a reference to the inner exception that is the cause of this exception.

Properties

Data Data Data Data

Ruft eine Auflistung von Schlüssel-Wert-Paaren ab, die zusätzliche benutzerdefinierte Informationen über die Ausnahme bereitstellen. Gets a collection of key/value pairs that provide additional user-defined information about the exception.

(Inherited from Exception)
HelpLink HelpLink HelpLink HelpLink

Ruft einen Link zu der mit dieser Ausnahme verbundenen Hilfedatei ab oder legt diesen fest. Gets or sets a link to the help file associated with this exception.

(Inherited from Exception)
HResult HResult HResult HResult

Ruft HRESULT ab oder legt HRESULT fest. Dies ist ein codierter Wert, der einer bestimmten Ausnahme zugeordnet ist. Gets or sets HRESULT, a coded numerical value that is assigned to a specific exception.

(Inherited from Exception)
InnerException InnerException InnerException InnerException

Ruft die Exception-Instanz ab, die die aktuelle Ausnahme verursacht hat. Gets the Exception instance that caused the current exception.

(Inherited from Exception)
Message Message Message Message

Ruft die Fehlermeldung und den Parameternamen oder nur die Fehlermeldung ab, wenn kein Parametername festgelegt ist. Gets the error message and the parameter name, or only the error message if no parameter name is set.

ParamName ParamName ParamName ParamName

Ruft den Namen des Parameters ab, der diese Ausnahme auslöst. Gets the name of the parameter that causes this exception.

Source Source Source Source

Gibt den Namen der Anwendung oder des Objekts zurück, die bzw. das den Fehler verursacht hat, oder legt diesen fest. Gets or sets the name of the application or the object that causes the error.

(Inherited from Exception)
StackTrace StackTrace StackTrace StackTrace

Ruft eine Zeichenfolgendarstellung der unmittelbaren Frames in der Aufrufliste ab. Gets a string representation of the immediate frames on the call stack.

(Inherited from Exception)
TargetSite TargetSite TargetSite TargetSite

Ruft die Methode ab, die die aktuelle Ausnahme auslöst. Gets the method that throws the current exception.

(Inherited from Exception)

Methods

Equals(Object) Equals(Object) Equals(Object) Equals(Object)

Bestimmt, ob das angegebene Objekt mit dem aktuellen Objekt identisch ist. Determines whether the specified object is equal to the current object.

(Inherited from Object)
GetBaseException() GetBaseException() GetBaseException() GetBaseException()

Gibt beim Überschreiben in einer abgeleiteten Klasse eine Exception zurück, die die ursprüngliche Ursache für eine oder mehrere nachfolgende Ausnahmen ist. When overridden in a derived class, returns the Exception that is the root cause of one or more subsequent exceptions.

(Inherited from Exception)
GetHashCode() GetHashCode() GetHashCode() GetHashCode()

Fungiert als die Standardhashfunktion. Serves as the default hash function.

(Inherited from Object)
GetObjectData(SerializationInfo, StreamingContext) GetObjectData(SerializationInfo, StreamingContext) GetObjectData(SerializationInfo, StreamingContext) GetObjectData(SerializationInfo, StreamingContext)

Legt das SerializationInfo-Objekt mit dem Parameternamen und zusätzlichen Informationen zur Ausnahme fest. Sets the SerializationInfo object with the parameter name and additional exception information.

GetType() GetType() GetType() GetType()

Ruft den Laufzeittyp der aktuellen Instanz ab. Gets the runtime type of the current instance.

(Inherited from Exception)
MemberwiseClone() MemberwiseClone() MemberwiseClone() MemberwiseClone()

Erstellt eine flache Kopie des aktuellen Object. Creates a shallow copy of the current Object.

(Inherited from Object)
ToString() ToString() ToString() ToString()

Erstellt eine Zeichenfolgendarstellung der aktuellen Ausnahme und gibt diese zurück. Creates and returns a string representation of the current exception.

(Inherited from Exception)

Events

SerializeObjectState SerializeObjectState SerializeObjectState SerializeObjectState

Tritt auf, wenn eine Ausnahme serialisiert wird, um ein Ausnahmezustandsobjekt zu erstellen, das serialisierte Daten für die Ausnahme enthält. Occurs when an exception is serialized to create an exception state object that contains serialized data about the exception.

(Inherited from Exception)

Applies to

See Also